; May 03 2016
(setq ph (make-hash-table :test #'equal))
(setq mh (make-hash-table :test #'equal))

(setq mscutoff 93000)

(defun a (f)
  (setq resf (open f :direction :input))
  (loop while (setq l (read resf nil nil)) do
	(when (and (car l) (member (caddr l) '(20 25) :test #'equal))
	  (let* ((p (if (equal (aref (car l) 0) #\/) (if (eq (aref (car l) 35) #\/) (subseq (car l) 36) (subseq (car l) 35)) (car l)))
		 (m (if (consp (cadr l)) (caadr l) (cadr l)))
		 (php (gethash p ph))
		 (mhm (gethash m mh))
		 (pa (assoc m php :test #'equal))
		 (ma (assoc p mhm :test #'equal))
		 (ms (cadddr l)))
	    (when (and (< ms mscutoff) (not (consp m)))
	      (if pa
		  (setf (gethash p ph) (acons m (min ms (cdr pa)) (remove pa php :test #'equal)))
		(push (cons m ms) (gethash p ph)))
	      (if ma
		  (setf (gethash m mh) (acons p (min ms (cdr ma)) (remove ma mhm :test #'equal)))
		(push (cons p ms) (gethash m mh)))))))
  (close resf))

(defun reload ()
  (setq ph (make-hash-table :test #'equal))
  (setq mh (make-hash-table :test #'equal))
  (a "results")
  )

(defun bestnext (unsolved modesupto)
  (let ((r nil))
    (dolist (ms modesupto)
      (let* ((m (car ms))
	     (s (cadr ms))
	     (u (+ s 100))
	     (pl (remove-if-not #'(lambda (ps) (and (member (car ps) unsolved :test #'equal) (< (cdr ps) u))) (gethash m mh))))
	(when pl (push (list m u pl) r))))
    (sort r #'> :key #'(lambda (x) (length (caddr x))))))

(defun greedy1b (unsolved modesupto)
  (if unsolved
      (let ((r (bestnext unsolved modesupto)))
	(if r
	    (cons (car r)
		  (greedy1b (set-difference unsolved (mapcar #'car (caddar r)) :test #'equal)
			    (mapcar #'(lambda (ms)
					(if (equal (car ms) (caar r))
					    (list (car ms) (cadar r))
					  ms))
				    modesupto)))
	  (greedy1b unsolved (mapcar #'(lambda (ms) (list (car ms) (+ (cadr ms) 100))) modesupto))))
    nil))

(defun greedy1 ()
  (let ((unsolved nil)
	(modesupto nil)
	(uniqpart nil)
	(coveredbyuniqpart nil)
	(uniqmodes nil))
    (maphash #'(lambda (k v) ; unique way to solve the problem, so the mode is forced to be part of the schedule
		 (when (= (length v) 1)
		   (let ((m (caar v))
			 (s (+ 100 (* 100 (floor (/ (cdar v) 100))))))
		     (let ((a (assoc m uniqmodes :test #'equal)))
		       (if a
			   (when (> s (cdr a))
			     (setq uniqmodes (acons m s (remove a uniqmodes))))
			 (push (cons m s) uniqmodes))))))
	     ph)
    (dolist (ms uniqmodes)
      (let ((psl nil))
	(dolist (ps (gethash (car ms) mh))
	  (when (and (< (cdr ps) (cdr ms)) (not (member (car ps) coveredbyuniqpart :test #'equal))) (push ps psl) (push (car ps) coveredbyuniqpart)))
	(push (list (car ms) (cdr ms) psl) uniqpart)))
    (setq modesupto (mapcar #'(lambda (ms) (list (car ms) (cdr ms))) uniqmodes))
    (maphash #'(lambda (k v) (unless (member k coveredbyuniqpart :test #'equal) (push k unsolved))) ph)
    (maphash #'(lambda (k v) (unless (assoc k modesupto :test #'equal) (push (list k 0) modesupto))) mh)
    (format t "unsolved ~d~%~S~%" (length unsolved) unsolved)
    (append uniqpart (greedy1b unsolved modesupto))))

(defun greedy2 (assumedmodes)
  (let ((unsolved nil)
	(modesupto nil)
	(assumedpart nil)
	(coveredbyassumedpart nil))
    (dolist (ms assumedmodes)
      (let ((psl nil))
	(dolist (ps (gethash (car ms) mh))
	  (when (and (< (cdr ps) (cdr ms)) (not (member (car ps) coveredbyassumedpart :test #'equal))) (push ps psl) (push (car ps) coveredbyassumedpart)))
	(push (list (car ms) (cdr ms) psl) assumedpart)))
    (setq modesupto (mapcar #'(lambda (ms) (list (car ms) (cdr ms))) assumedmodes))
    (maphash #'(lambda (k v) (unless (member k coveredbyassumedpart :test #'equal) (push k unsolved))) ph)
    (maphash #'(lambda (k v) (unless (assoc k modesupto :test #'equal) (push (list k 0) modesupto))) mh)
    (append assumedpart (greedy1b unsolved modesupto))))

(defun simplify-schedule (sch)
  (if sch
      (let ((m (caar sch))
	    (u (cadar sch))
	    (pl (caddar sch))
	    (schr nil))
	(dolist (x (cdr sch))
	  (if (equal (car x) m)
	      (progn
		(setq u (max u (cadr x)))
		(setq pl (append pl (caddr x))))
	    (push x schr)))
	(cons (list m u pl) (simplify-schedule (reverse schr))))
    nil))

(defun chop-schedule (sch lim)
  (if sch
      (let ((m (caar sch))
	    (u (cadar sch))
	    (pl (remove-if #'(lambda (x) (> (cdr x) lim)) (caddar sch))))
	(if pl
	    (cons (list m u pl) (chop-schedule (cdr sch) lim))
	  (chop-schedule (cdr sch) lim)))
    nil))

(defun normalize-schedule (sch nf)
  (mapcar #'(lambda (x) (let ((pl (mapcar #'(lambda (p) (cons (car p) (funcall nf (cdr p)))) (caddr x)))) (list (car x) (apply #'max (mapcar #'cdr pl)) pl))) sch))
